SystemOrganization addCategory: #'GMF-GraphicModel'!

Object subclass: #DataClass
	instanceVariableNames: 'metaModelClass positionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!DataClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 11/3/2013 13:25'!
mmClass: XmetaModelClass pClass: XpositionClass
	^ super new
		initialize;
		metaModelClass: XmetaModelClass;
		positionClass: XpositionClass;
		yourself! !

!DataClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:27'!
metaModelClass
	^metaModelClass! !

!DataClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:27'!
metaModelClass: xClass
	metaModelClass := xClass.! !

!DataClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:27'!
positionClass
	^positionClass! !

!DataClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:27'!
positionClass: xClass
	positionClass := xClass.! !

Object subclass: #DrawDiagram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!DrawDiagram class methodsFor: 'public' stamp: 'RostislavNovk 11/3/2013 14:55'!
draw: dataModel
	dataModel do:[ :d | (d metaModelClass isClass) ifTrue:[ self drawClass: d.]
					      ifFalse:[self drawassociation: d] ].! !

!DrawDiagram class methodsFor: 'public' stamp: 'RostislavNovk 11/3/2013 15:04'!
drawClass: xClass
	| x y mmClass |
	mmClass := xClass metaModelClass.
	x := xClass positionClass leftTopPoint x+5.
	y := xClass positionClass leftTopPoint y+5.
	Transcript show: 'Box ', name; cr.
	"Square newX: (xClass aX) Y: (xClass aY) X2: (xClass bX) Y2: (xClass bY)."
	self drawText: mmClass name X: x Y: y.
	y := y+16.
	self drawText: mmClass name X: x Y: y.
	y := y+16.
	"DrawLine draw."
	Transcript show: '----------'; cr.
	mmClass attributs do:[:d | self drawText: d name X: x Y: y. y := y+16. ].
	"DrawLine draw."
	Transcript show: '----------'; cr.
	mmClass methods do:[:d | self drawText: d name X: x Y: y. y := y+16. ].
	Transcript show: ''; cr.
	
	! !

!DrawDiagram class methodsFor: 'public' stamp: 'RostislavNovk 10/29/2013 18:05'!
drawText: xText X: xX Y: xY
	Transcript show: xText; cr.! !

!DrawDiagram class methodsFor: 'public' stamp: 'RostislavNovk 11/3/2013 15:06'!
drawassociation: xAssociation
	| mmClass pClass |
	mmClass := xAssociation metaModelClass.
	pClass  := xAssociation positionClass.
	"DrawLine aX aY bX bY"
	Transcript show: '----------'; cr.
	self drawText: mmClass startQuantity X: pClass start x Y: pClass start y.
	self drawText: mmClass endQuantity X: pClass end x Y: pClass end y.
	self drawText: mmClass name X: pClass middlePoint x Y: pClass middlePoint y.
	! !

Object subclass: #Drawer
	instanceVariableNames: ''
	classVariableNames: 'fillColor font lineColor lineWidth surface'
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!Drawer commentStamp: '<historical>' prior: 0!
A Drawer is me and I would like to draw.

Class Variables
	fillColor:		<Color>
	lineColor:		<Color>
	lineWidth:		<Integer>
	surface:		<AthensCairoSurface>
	font:			<LogicalFont>

fillColor
	- filling for rectangles

lineColor
	- color of lines for lines and rectangle's edges too

lineStyle
	- style of lines for lines and rectangle's edges too

lineWidth
	- width of lines for lines and rectangle's edges too

surface
	- surface where to draw to

font
	- font to text methods!

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:26'!
fillColor
	"getter of Color for filling"

	^ fillColor! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:26'!
fillColor: xColor
	"setter of Color for filling"

	fillColor := xColor! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
font
	"getter of font"

	^ font! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
font: xFont
	"setter of font
	font := LogicalFont familyName: 'Arial' pointSize: 20."

	font := xFont! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineColor
	"getter of Color for lines"

	^ lineColor! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineColor: xColor
	"setter of Color for lines"

	lineColor := xColor! !

!Drawer class methodsFor: 'drawing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineDashedX: xPoint Y: yPoint dash:anInteger
	"drawing of line X and Y are absolute"

	| path |
	surface
		drawDuring: [ :canvas | 
			| stroke |
			canvas pathTransform translateBy: 0 @ 0.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: yPoint
				].
			canvas setShape: path.
			stroke := canvas setStrokePaint: lineColor.
			stroke
				width: lineWidth;
				joinRound;
				capRound;
				dashes: ( Array braceWith:anInteger with: (3/4)*anInteger ) offset: 0.
			canvas draw
		].
	^self! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineWidth
	"getter of width for lines"

	^ lineWidth! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineWidth: xInteger
	"setter of width for lines"

	lineWidth := xInteger! !

!Drawer class methodsFor: 'drawing' stamp: 'JiriMertin 11/13/2013 22:27'!
lineX: xPoint Y: yPoint
	"drawing of line X and Y are absolute"

	| path |
	surface
		drawDuring: [ :canvas | 
			canvas pathTransform translateBy: 0 @ 0.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: xPoint;
						lineTo: yPoint
				].
			canvas setShape: path.
			(canvas setStrokePaint: lineColor) width: lineWidth ; capRound.
			canvas draw 
		].
	^self! !

!Drawer class methodsFor: 'drawing' stamp: 'JiriMertin 11/13/2013 22:27'!
rectangleX: xPoint Y: yPoint
	"drawing of rectangle
	uses fillColor for filling
	uses lineColor and lineWidth for edges
	X and Y are absolute"

	| path |
	surface
		drawDuring: [ :canvas | 
			canvas pathTransform translateBy: 0 @ 0.
			path := canvas
				createPath: [ :builder | 
					builder
						absolute;
						moveTo: 	xPoint;
						lineToX: xPoint x Y: yPoint y;
						lineTo: 		yPoint;
						lineToX: xPoint y Y: yPoint x;
						close
					].
			canvas setShape: path.
			
			canvas setPaint: fillColor.
			canvas draw.
			
			(canvas setStrokePaint: lineColor) width: lineWidth ; joinRound.
			canvas draw
		].
	^self! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
surface
	"getter of surface"

	^ surface! !

!Drawer class methodsFor: 'accessing' stamp: 'JiriMertin 11/13/2013 22:27'!
surface: xSurface
	"setter of surface"

	surface := xSurface! !

!Drawer class methodsFor: 'drawing' stamp: 'JiriMertin 11/13/2013 22:27'!
textString: aString X: aPoint
	"drawing of text"

	"| font |
	font := LogicalFont familyName: 'Arial' pointSize: 20."
	
	surface
		drawDuring: [ :canvas | 
			canvas pathTransform translateX: (aPoint x) Y: (aPoint y + font getPreciseAscent).
			canvas setFont: font ; setPaint: lineColor.
			canvas drawString: aString.
		].
	^self! !

!Drawer class methodsFor: 'drawing' stamp: 'JiriMertin 11/13/2013 22:27'!
textString: aString X: aPoint maxWidth: anInteger
	"drawing of text into closed area"

	| shortedString |
	
	shortedString := aString.
	[ (font widthOfString: shortedString) > anInteger ] whileTrue: 
		[ shortedString := shortedString copyFrom: 1 to: shortedString size - 1 ]. "uneficient for long strings, TODO maybe later"
	
	^self textString: shortedString X: aPoint.! !

Object subclass: #PositionClass
	instanceVariableNames: 'leftTopPoint rightBottomPoint middlePoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!PositionClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 11/3/2013 14:03'!
leftTopPoint: xPoint rightBottomPoint: xxPoint
	^ super new
		initialize;
		leftTopPoint: xPoint;
		rightBottomPoint: xxPoint;
		yourself! !

!PositionClass class methodsFor: 'instance creation' stamp: 'RostislavNovk 11/3/2013 13:48'!
new
	^ super new
		initialize;
		yourself! !

!PositionClass methodsFor: 'initialize-release' stamp: 'RostislavNovk 11/3/2013 14:39'!
initialize 
	leftTopPoint := Point x: 0 y: 0.
	rightBottomPoint := Point x: 25 y: 25.
	middlePoint := Point x: 0 y: 0.
	self refreshMiddle.! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
leftTopPoint
	^ leftTopPoint! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
leftTopPoint: anObject
	leftTopPoint := anObject! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
middlePoint
	^ middlePoint! !

!PositionClass methodsFor: 'private' stamp: 'RostislavNovk 11/3/2013 14:02'!
middlePoint: anObject
	middlePoint := anObject! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:39'!
refreshMiddle
	middlePoint := Point x: (leftTopPoint x + rightBottomPoint x) / 2 y: (leftTopPoint y + rightBottomPoint y) / 2! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
rightBottomPoint
	^ rightBottomPoint! !

!PositionClass methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:02'!
rightBottomPoint: anObject
	rightBottomPoint := anObject! !

PositionClass subclass: #PositionLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

PositionLine subclass: #PositionGroupOfLines
	instanceVariableNames: 'lines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-GraphicModel'!

!PositionGroupOfLines class methodsFor: 'instance creation' stamp: 'RostislavNovk 11/3/2013 13:55'!
new 
	^super new initialize; yourself.! !

!PositionGroupOfLines methodsFor: 'initialize-release' stamp: 'RostislavNovk 11/3/2013 13:54'!
initialize
	lines := OrderedCollection new.! !

!PositionGroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 13:54'!
lines
	^ lines copy.! !

!PositionGroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:36'!
lines: anObject
	lines add: anObject.
	self refreshPosition.! !

!PositionGroupOfLines methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:39'!
refreshPosition
	super leftTopPoint: lines first start.
	super rightBottomPoint: lines last end.
	self refreshMiddle.! !

!PositionLine methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:28'!
end
	^rightBottomPoint! !

!PositionLine methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:28'!
end: anObject
	rightBottomPoint := anObject! !

!PositionLine methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:28'!
start
	^leftTopPoint ! !

!PositionLine methodsFor: 'accessing' stamp: 'RostislavNovk 11/3/2013 14:28'!
start: anObject
	leftTopPoint := anObject! !
